#pragma once

namespace OhioState
{
	namespace Graphics 
	{
		//
		// Pure Abstract base class for all lights
		//
		class ILight
		{
		public:
			//
			// Enable the light.
			//
			virtual void Enable(int lightSlot) = 0;
			//
			// Disable the light.
			//
			virtual void Disable(int lightSlot) = 0;
		};
	}
}